## mingw-w64-onevpl-cpu-2022.2.4-1.src.tar.zst

=== CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
# oneAPI Video Processing Library (oneVPL) main build script
if(MSVC)
  cmake_minimum_required(VERSION 3.15)
  cmake_policy(SET CMP0091 NEW)
else()
  cmake_minimum_required(VERSION 3.10.2)
endif()

set(CMAKE_NO_SYSTEM_FROM_IMPORTED
    ON
    CACHE BOOL "Do not treat contents of the
  INTERFACE_INCLUDE_DIRECTORIES of IMPORTED targets as system includes" FORCE)

file(STRINGS "version.txt" version_txt)
project(oneVPL-cpu VERSION ${version_txt})

# More code hardening on Windows
if(MSVC)
  if(${use_control_flow_guard})
    message("Setting CONTROL FLOW GUARD")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /guard:cf")
    set(CMAKE_EXE_LINKER_FLAGS "/guard:cf /DYNAMICBASE")
  endif()
  if(${use_qspectre})
    message("Setting QSPECTRE")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /Qspectre")
  endif()
endif()

#
# Project configuration options
#

# Project options
option(BUILD_TESTS "Build tests." ON)
option(BUILD_GPL_X264 "Build GPL X264" OFF)
option(BUILD_OPENH264 "Build openH264" OFF)
option(USE_EXPERIMENTAL_API "Enable oneVPL Experimental API." ON)
option(USE_ONEAPI_INSTALL_LAYOUT "Use oneAPI install layout instead of FHS" OFF)
option(USE_MSVC_STATIC_RUNTIME
       "Link MSVC runtime statically to all components." OFF)

if(USE_MSVC_STATIC_RUNTIME)
  set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
endif()
if(USE_ONEAPI_INSTALL_LAYOUT)
  set(CMAKE_INSTALL_DOCDIR "documentation")
  set(CMAKE_INSTALL_LIBDIR "lib")
  set(ONEAPI_INSTALL_ENVDIR "env")
  set(ONEAPI_INSTALL_SYSCHECKDIR "sys_check")
  set(ONEAPI_INSTALL_MODFILEDIR "modulefiles")
  set(ONEAPI_INSTALL_EXAMPLEDIR "examples")
  set(ONEAPI_INSTALL_LICENSEDIR "licensing/oneVPL-CPU")
  set(ONEAPI_INSTALL_PYTHONDIR "python/lib")
endif()

# Set output directories
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

include(cmake/oneAPIInstallDirs.cmake)

# Set POSITION_INDEPENDENT_CODE property for all targets
set(CMAKE_POSITION_INDEPENDENT_CODE true)

# Keep executable bits on shared objects when installing regardless of distro
set(CMAKE_INSTALL_SO_NO_EXE 0)

include(cmake/CompileOptions.cmake)

if(NOT BUILD_GPL_X264)
  if(CMAKE_SIZEOF_VOID_P EQUAL 8)
    set(BUILD_OPENH264 ON)
  endif()
endif()

add_subdirectory(cpu)

install(
  FILES third-party-programs.txt
  DESTINATION ${ONEAPI_INSTALL_LICENSEDIR}
  COMPONENT license)

install(
  FILES LICENSE
  RENAME license.txt
  DESTINATION ${ONEAPI_INSTALL_LICENSEDIR}
  COMPONENT license)

include(cmake/PackageTarget.cmake)
include(InstallRequiredSystemLibraries)

if(BUILD_TESTS)
  include(Dart)
  enable_testing()
  include(GoogleTest)
  add_subdirectory(test/unit)
endif()

message(
  STATUS "---------------- Configuration summary ------------------------------"
)
message(STATUS "CMake:")
message(STATUS "  CMAKE_VERSION                  : ${CMAKE_VERSION}")
message(STATUS "  CMAKE_GENERATOR                : ${CMAKE_GENERATOR}")
message(STATUS "  CMAKE_BUILD_TOOL               : ${CMAKE_BUILD_TOOL}")
message(STATUS "Target:")
message(STATUS "  CMAKE_SYSTEM_NAME              : ${CMAKE_SYSTEM_NAME}")
message(STATUS "  CMAKE_SYSTEM_VERSION           : ${CMAKE_SYSTEM_VERSION}")
message(STATUS "  CMAKE_SYSTEM_PROCESSOR         : ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS "General:")
message(STATUS "  CMAKE_BUILD_TYPE               : ${CMAKE_BUILD_TYPE}")
message(STATUS "  CMAKE_TOOLCHAIN_FILE           : ${CMAKE_TOOLCHAIN_FILE}")
message(STATUS "  CMAKE_C_COMPILER               : ${CMAKE_C_COMPILER}")
message(STATUS "  CMAKE_CXX_COMPILER             : ${CMAKE_CXX_COMPILER}")
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  message(STATUS "  Build architecture             : 64-bit")
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
  message(STATUS "  Build architecture             : 32-bit")
endif()
message(STATUS "Flags:")
message(STATUS "  CMAKE_C_FLAGS                  : ${CMAKE_C_FLAGS}")
message(STATUS "  CMAKE_CXX_FLAGS                : ${CMAKE_CXX_FLAGS}")
message(STATUS "Release flags:")
message(STATUS "  CMAKE_C_FLAGS_RELEASE          : ${CMAKE_C_FLAGS_RELEASE}")
message(STATUS "  CMAKE_CXX_FLAGS_RELEASE        : ${CMAKE_CXX_FLAGS_RELEASE}")
message(STATUS "Debug flags:")
message(STATUS "  CMAKE_C_FLAGS_DEBUG            : ${CMAKE_C_FLAGS_DEBUG}")
message(STATUS "  CMAKE_CXX_FLAGS_DEBUG          : ${CMAKE_CXX_FLAGS_DEBUG}")
message(STATUS "RelWithDebRT flags:")
message(
  STATUS "  CMAKE_C_FLAGS_RELWITHDEBRT     : ${CMAKE_C_FLAGS_RELWITHDEBRT}")
message(
  STATUS "  CMAKE_CXX_FLAGS_RELWITHDEBRT   : ${CMAKE_CXX_FLAGS_RELWITHDEBRT}")
message(STATUS "Install:")
message(STATUS "  CMAKE_INSTALL_PREFIX           : ${CMAKE_INSTALL_PREFIX}")
message(
  STATUS "  CMAKE_INSTALL_FULL_BINDIR      : ${CMAKE_INSTALL_FULL_BINDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_INCLUDEDIR  : ${CMAKE_INSTALL_FULL_INCLUDEDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_LIBDIR      : ${CMAKE_INSTALL_FULL_LIBDIR}")
message(
  STATUS "  CMAKE_INSTALL_FULL_DOCDIR      : ${CMAKE_INSTALL_FULL_DOCDIR}")
message(
  STATUS "  ONEAPI_INSTALL_FULL_ENVDIR     : ${ONEAPI_INSTALL_FULL_ENVDIR}")
message(
  STATUS "  ONEAPI_INSTALL_FULL_SYSCHECKDIR: ${ONEAPI_INSTALL_FULL_SYSCHECKDIR}"
)
message(
  STATUS "  ONEAPI_INSTALL_FULL_MODFILEDIR : ${ONEAPI_INSTALL_FULL_MODFILEDIR}")
message(
  STATUS "  ONEAPI_INSTALL_FULL_EXAMPLEDIR : ${ONEAPI_INSTALL_FULL_EXAMPLEDIR}")
message(
  STATUS "  ONEAPI_INSTALL_FULL_LICENSEDIR : ${ONEAPI_INSTALL_FULL_LICENSEDIR}")
message(
  STATUS "  ONEAPI_INSTALL_FULL_PYTHONDIR  : ${ONEAPI_INSTALL_FULL_PYTHONDIR}")
message(STATUS "Build:")
message(STATUS "  BUILD_TESTS                        : ${BUILD_TESTS}")
message(STATUS "  BUILD_GPL_X264                     : ${BUILD_GPL_X264}")
message(STATUS "  USE_EXPERIMENTAL_API               : ${USE_EXPERIMENTAL_API}")

if(MSVC)
  message(
    STATUS "  USE_MSVC_STATIC_RUNTIME        : ${USE_MSVC_STATIC_RUNTIME}")
endif()

=== cpu/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################
cmake_minimum_required(VERSION 3.10.2)

file(STRINGS "version.txt" version_txt)
project(vpl VERSION ${version_txt})

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(TARGET vplswref64)
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(TARGET vplswref32)
endif()

# add lib/<arch> to find_package path on windows
if(WIN32 AND CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(CMAKE_LIBRARY_ARCHITECTURE x86)
endif()

file(GLOB SOURCES src/*.cpp)

if(WIN32)
  list(APPEND SOURCES src/windows/libmfxsw.def)
endif()

add_library(${TARGET} SHARED "")

if(USE_EXPERIMENTAL_API)
  add_definitions(-DONEVPL_EXPERIMENTAL)
endif()

# force correct name on Windows
set_target_properties(${TARGET} PROPERTIES PREFIX "lib")

if(UNIX)
  set_target_properties(${TARGET} PROPERTIES SUFFIX ".so.1")
endif()

target_sources(${TARGET} PRIVATE ${SOURCES})

if(POLICY CMP0074)
  # ignore warning of VPL_ROOT in find_package search path
  cmake_policy(SET CMP0074 OLD)
endif()

find_package(VPL 2.4 REQUIRED COMPONENTS api)
message(STATUS "Found VPL (version ${VPL_VERSION})")
target_link_libraries(${TARGET} PUBLIC VPL::api)

if(BUILD_GPL_X264)
  add_definitions("-DENABLE_ENCODER_X264")
elseif(BUILD_OPENH264)
  add_definitions("-DENABLE_ENCODER_OPENH264")
endif()

add_subdirectory(ext/ffmpeg-codecs)

target_link_libraries(${TARGET} PRIVATE ffmpeg-codecs)

target_include_directories(${TARGET} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}
                                             ${CMAKE_CURRENT_BINARY_DIR})
target_compile_definitions(
  ${TARGET}
  PRIVATE -DVPL_VERSION_MAJOR=${PROJECT_VERSION_MAJOR}
          -DVPL_VERSION_MINOR=${PROJECT_VERSION_MINOR}
          -DVPL_VERSION_PATCH=${PROJECT_VERSION_PATCH})

if(UNIX)
  set_target_properties(${TARGET} PROPERTIES LINK_FLAGS -Wl,-Bsymbolic,-z,defs)
endif()

install(
  TARGETS ${TARGET}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT runtime
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT runtime)

=== test/unit/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) 2020 Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

set(gtest_force_shared_crt
    ON
    CACHE BOOL "" FORCE)
set(INSTALL_GTEST
    OFF
    CACHE BOOL "" FORCE)
add_subdirectory(googletest)

set(TARGET vpl-utest)

set(SOURCE_FILES
    main.cpp
    api/test_bitstream_96x64_8bit_hevc.cpp
    api/test_bitstream_96x64_10bit_hevc.cpp
    api/test_bitstream_32x32_mjpeg.cpp
    api/x_getvideoparam.cpp
    api/core.cpp
    api/x_query.cpp
    api/session_management.cpp
    api/memory.cpp
    api/x_init_reset_close.cpp
    api/x_xframeasync.cpp
    api/x_queryiosurf.cpp
    api/decodeheader.cpp
    api/x_notimplemented.cpp)

add_executable(${TARGET} ${SOURCE_FILES})
set_property(TARGET ${TARGET} PROPERTY CXX_STANDARD 14)

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  message(STATUS "Linking vpl-utest against vplswref64")
  set(DEPENDENT_LIBS vplswref64)
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
  message(STATUS "Linking vpl-utest against vplswref32")
  set(DEPENDENT_LIBS vplswref32)
endif()
target_link_libraries(${TARGET} ${DEPENDENT_LIBS})
find_package(VPL REQUIRED)
target_link_libraries(${TARGET} VPL::api)

target_link_libraries(${TARGET} gtest)
target_include_directories(${TARGET} PRIVATE ${CMAKE_SOURCE_DIR}/test/unit)
# gtest_add_tests instead of gtest_discover_tests(${TARGET}) allows building
# test list without loading the dispatcher
gtest_add_tests(TARGET ${TARGET})

=== cpu/ext/ffmpeg-codecs/CMakeLists.txt ===
# ##############################################################################
# Copyright (C) Intel Corporation
#
# SPDX-License-Identifier: MIT
# ##############################################################################

# This is WA until we have a solution to find right library location from gcc
# output.
#
# findMingwLib() looks for varLibName from varMingwPath + varGccPath folder at
# first, and if it fails then, it looks for varMingwPath + 'lib' path Because we
# observed only 2 locations for libs so far.
#
function(findMingwLib varResult varMingwPath varGccPath varLibName)
  set(fileName ${varMingwPath}/${varGccPath}/${varLibName})
  if(NOT EXISTS ${fileName})
    set(fileName ${varMingwPath}/lib/${varLibName})
  endif()
  set(${varResult}
      ${fileName}
      PARENT_SCOPE)
endfunction()

cmake_minimum_required(VERSION 3.10.2)

set(TARGET ffmpeg-codecs)

add_library(${TARGET} INTERFACE)

# Set VPL dependencies directory
if(NOT DEFINED ENV{VPL_BUILD_DEPENDENCIES})
  set(VPL_DEP_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../../_deps)
  message(STATUS "Using default destination located at ${VPL_DEP_DIR}")
else()
  set(VPL_DEP_DIR $ENV{VPL_BUILD_DEPENDENCIES})
  message(STATUS "Using VPL_BUILD_DEPENDENCIES located at ${VPL_DEP_DIR}")
endif()

# Set basic FFmpeg and codec libs
if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "8")
  set(SVTHEVCENC_LIB ${VPL_DEP_DIR}/lib/libSvtHevcEnc.a)
  set(SVTAV1ENC_LIB ${VPL_DEP_DIR}/lib/libSvtAv1Enc.a)
  set(DAV1D_LIB ${VPL_DEP_DIR}/lib/libdav1d.a)

  if(NOT EXISTS ${SVTHEVCENC_LIB}
     OR NOT EXISTS ${SVTAV1ENC_LIB}
     OR NOT EXISTS ${DAV1D_LIB})
    message(FATAL_ERROR "Could not find expected codec libraries")
  endif()
endif()

set(AVCODEC_LIB ${VPL_DEP_DIR}/lib/libavcodec.a)
set(AVUTIL_LIB ${VPL_DEP_DIR}/lib/libavutil.a)
set(AVFILTER_LIB ${VPL_DEP_DIR}/lib/libavfilter.a)
set(SWSCALE_LIB ${VPL_DEP_DIR}/lib/libswscale.a)

if(NOT EXISTS ${AVCODEC_LIB}
   OR NOT EXISTS ${AVUTIL_LIB}
   OR NOT EXISTS ${AVFILTER_LIB}
   OR NOT EXISTS ${SWSCALE_LIB})
  message(FATAL_ERROR "Could not find expected FFmpeg libraries")
endif()

set_property(TARGET ${TARGET} PROPERTY INTERFACE_INCLUDE_DIRECTORIES
                                       ${VPL_DEP_DIR}/include)

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
set(THREADS_PREFER_PTHREAD_FLAG TRUE)
find_package(Threads REQUIRED)

# Add basic FFmpeg and codec libs
if(WIN32)
  if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "4")
    target_link_libraries(
      ${TARGET} INTERFACE ${AVCODEC_LIB} ${AVUTIL_LIB} ${AVFILTER_LIB}
                          ${SWSCALE_LIB} Threads::Threads)
  elseif("${CMAKE_SIZEOF_VOID_P}" STREQUAL "8")
    target_link_libraries(
      ${TARGET}
      INTERFACE ${AVCODEC_LIB}
                ${AVUTIL_LIB}
                ${AVFILTER_LIB}
                ${SWSCALE_LIB}
                ${SVTHEVCENC_LIB}
                ${SVTAV1ENC_LIB}
                ${DAV1D_LIB}
                Threads::Threads)
  endif()
else()
  if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "4")
    target_link_libraries(
      ${TARGET} INTERFACE ${AVCODEC_LIB} ${AVUTIL_LIB} ${AVFILTER_LIB}
                          ${SWSCALE_LIB} Threads::Threads ${CMAKE_DL_LIBS})
  elseif("${CMAKE_SIZEOF_VOID_P}" STREQUAL "8")
    target_link_libraries(
      ${TARGET}
      INTERFACE ${AVCODEC_LIB}
                ${AVUTIL_LIB}
                ${AVFILTER_LIB}
                ${SWSCALE_LIB}
                ${SVTHEVCENC_LIB}
                ${SVTAV1ENC_LIB}
                ${DAV1D_LIB}
                Threads::Threads
                ${CMAKE_DL_LIBS})
  endif()
endif()

# Get Mingw info, common to all cases if OS is Windows
if(WIN32)
  if(NOT DEFINED ENV{MSYS_ROOT})
    message(STATUS "MSYS_ROOT not defined, assuming C:/tools/msys64")
    set(MSYS_ROOT C:/tools/msys64)
  else()
    file(TO_CMAKE_PATH "$ENV{MSYS_ROOT}" MSYS_ROOT)
  endif()

  if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "8")
    set(mingw_name mingw64)
    set(gcc_name x86_64-w64-mingw32)
  elseif("${CMAKE_SIZEOF_VOID_P}" STREQUAL "4")
    set(mingw_name mingw32)
    set(gcc_name i686-w64-mingw32)
  else()
    message(STATUS "${CMAKE_SIZEOF_VOID_P} * 8 bit")
    message(FATAL_ERROR "Cannot identify library folder")
  endif()

  set(MINGW_PATH ${MSYS_ROOT}/${mingw_name})

  execute_process(COMMAND ${MINGW_PATH}/bin/gcc.exe --version
                  OUTPUT_VARIABLE gcc_version_text)
  string(REGEX MATCH "[0-9]+\\.[0-9]+\\.[0-9]+" gcc_version ${gcc_version_text})
endif()

# Set AVC encoder lib name
if(BUILD_GPL_X264)
  set(H264_ENC_LIB ${VPL_DEP_DIR}/lib/libx264.a)
  if(NOT EXISTS ${H264_ENC_LIB})
    message(FATAL_ERROR "Could not find x264 libraries")
  else()
    message(STATUS "Building with GPL x264 for AVC implementation")
  endif()
elseif(BUILD_OPENH264)
  set(H264_ENC_LIB ${VPL_DEP_DIR}/lib/libopenh264.a)
  if(NOT EXISTS ${H264_ENC_LIB})
    message(FATAL_ERROR "Could not find openh264 libraries")
  else()
    message(STATUS "Building with openH264 for AVC implementation")
  endif()
endif()

# Add AVC encoder libs
target_link_libraries(${TARGET} INTERFACE ${H264_ENC_LIB})

if(WIN32)
  # openH264 lib dependencies
  if(BUILD_OPENH264)
    findmingwlib(STDCPP_LIB ${MINGW_PATH} lib/gcc/${gcc_name}/${gcc_version}
                 libstdc++.a)
    if(NOT EXISTS ${STDCPP_LIB})
      message(
        FATAL_ERROR "Could not find expected MinGW stdc++ runtime libraries")
    endif()

    # Add openH264 dependencies
    target_link_libraries(${TARGET} INTERFACE ${STDCPP_LIB})
  endif()

  # Common libs from mingw
  findmingwlib(GCC_LIB ${MINGW_PATH} lib/gcc/${gcc_name}/${gcc_version}
               libgcc.a)
  findmingwlib(GCC_EH_LIB ${MINGW_PATH} lib/gcc/${gcc_name}/${gcc_version}
               libgcc_eh.a)

  findmingwlib(BCRYPT_LIB ${MINGW_PATH} ${gcc_name}/lib libbcrypt.a)
  findmingwlib(MINGW32_LIB ${MINGW_PATH} ${gcc_name}/lib libmingw32.a)
  findmingwlib(MINGWEX_LIB ${MINGW_PATH} ${gcc_name}/lib libmingwex.a)
  findmingwlib(PTHREAD_IMPLIB ${MINGW_PATH} ${gcc_name}/lib libpthread.dll.a)

  if(NOT EXISTS ${GCC_LIB})
    message(FATAL_ERROR "Could not find expected MinGW GCC runtime libraries")
  endif()
  if(NOT EXISTS ${GCC_EH_LIB})
    message(
      FATAL_ERROR "Could not find expected MinGW GCC EH runtime libraries")
  endif()
  if(NOT EXISTS ${BCRYPT_LIB})
    message(
      FATAL_ERROR "Could not find expected MinGW BCrypt runtime libraries")
  endif()
  if(NOT EXISTS ${MINGW32_LIB})
    message(
      FATAL_ERROR "Could not find expected MinGW MinGW32 runtime libraries")
  endif()
  if(NOT EXISTS ${MINGWEX_LIB})
    message(
      FATAL_ERROR "Could not find expected MinGW MinGWEX runtime libraries")
  endif()
  if(NOT EXISTS ${PTHREAD_IMPLIB})
    message(FATAL_ERROR "Could not find expected MinGW runtime libraries")
  endif()

  # Add mingw libs
  target_link_libraries(
    ${TARGET} INTERFACE ${GCC_LIB} ${GCC_EH_LIB} ${BCRYPT_LIB} ${MINGW32_LIB}
                        ${MINGWEX_LIB} ${PTHREAD_IMPLIB})

  # libwinpthread dll
  set(PTHREAD_DLL ${MINGW_PATH}/bin/libwinpthread-1.dll)

  if(NOT EXISTS ${PTHREAD_DLL})
    message(
      FATAL_ERROR "Could not find expected MinGW PThread runtime libraries")
  endif()

  install(
    PROGRAMS ${PTHREAD_DLL}
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    COMPONENT runtime)
  # copy pthread dll to output directory so bins work without setting paths
  add_custom_target(mingw-dependencies)
  add_dependencies(${TARGET} mingw-dependencies)
  add_custom_command(
    TARGET mingw-dependencies
    COMMAND ${CMAKE_COMMAND} -E make_directory
            ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/)
  add_custom_command(
    TARGET mingw-dependencies
    COMMAND ${CMAKE_COMMAND} -E copy ${PTHREAD_DLL}
            ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/)

  # openH264 dll dependencies
  if(BUILD_OPENH264)
    set(STDCPP_DLL ${MINGW_PATH}/bin/libstdc++-6.dll)

    if("${CMAKE_SIZEOF_VOID_P}" STREQUAL "8")
      set(GCC_SEH_DLL ${MINGW_PATH}/bin/libgcc_s_seh-1.dll)
    elseif("${CMAKE_SIZEOF_VOID_P}" STREQUAL "4")
      set(GCC_SEH_DLL ${MINGW_PATH}/bin/libgcc_s_dw2-1.dll)
    endif()

    if(NOT EXISTS ${STDCPP_DLL})
      message(FATAL_ERROR "Could not find expected MinGW stdc++ runtime Dll")
    endif()
    if(NOT EXISTS ${GCC_SEH_DLL})
      message(
        FATAL_ERROR "Could not find expected MinGW GCC SEH runtime libraries")
    endif()

    install(
      PROGRAMS ${STDCPP_DLL} ${GCC_SEH_DLL}
      DESTINATION ${CMAKE_INSTALL_BINDIR}
      COMPONENT runtime)

    add_custom_command(
      TARGET mingw-dependencies
      COMMAND ${CMAKE_COMMAND} -E copy ${STDCPP_DLL} ${GCC_SEH_DLL}
              ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/${CMAKE_CFG_INTDIR}/)
  endif()
endif()

=== PKGBUILD ===
# Maintainer: Biswapriyo Nath <nathbappai@gmail.com>

_realname=onevpl-cpu
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2022.2.4
pkgrel=1
pkgdesc='oneVPL runtime implementation for CPU (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64')
url='https://www.somepackage.org/'
license=('spdx:MIT')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-meson"
             "${MINGW_PACKAGE_PREFIX}-nasm"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-onevpl"
             'git')
source=("https://github.com/oneapi-src/oneVPL-cpu/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        0001-disable-mingw-workaround.patch
        0002-bootstrap-fix-ffmpeg-command.patch
        0003-cmake-remove-unknown-options.patch
        0004-cmake-add-bcrypt-lib.patch)
sha256sums=('5a236a0c366db38d8d2e64e2df2e42f355b8a46175e78977f9f150d2d5bce81c'
            'e805e850b4827fe15c77a006207183f25aae1cdffb25856988100a8be834ce65'
            '1f495f6a5cee0ff6b8265288697a535cd08f6b0f113f2c560e7835f6044ec601'
            'c337ee9c8c86f3479d382c854f4fc7a88cf9bcf2e6d928ce679cba2f468a7596'
            'bd9c18382ae029b4b5b36dd8efc0735a2be3320c3a535429369276ba412cf15d')

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  patch -p1 -i "${srcdir}"/0001-disable-mingw-workaround.patch
  patch -p1 -i "${srcdir}"/0002-bootstrap-fix-ffmpeg-command.patch
  patch -p1 -i "${srcdir}"/0003-cmake-remove-unknown-options.patch

  # https://github.com/oneapi-src/oneVPL-cpu/pull/41
  patch -p1 -i "${srcdir}"/0004-cmake-add-bcrypt-lib.patch
}

build() {
  local -x PKG_CONFIG_LIBDIR="${srcdir}/deps-install/lib"
  local -x VPL_CPU_DEPS_BUILD_DIR="${srcdir}/deps-build"
  local -x VPL_BUILD_DEPENDENCIES="${srcdir}/deps-install"

  "oneVPL-cpu-${pkgver}/script/bootstrap" gpl

  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DCMAKE_PREFIX_PATH="${srcdir}/deps-install" \
      -DBUILD_GPL_X264=ON \
      -DBUILD_TESTS=OFF \
      -DONEAPI_INSTALL_LICENSEDIR="share/licenses/${_realname}" \
      "${extra_config[@]}" \
      ../${_realname}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .
}
